//Data structures used in this project, 
//nodes are the particle matter, and object3d defines the entire body of the water 
//written by Shiou-Min Shen

#include <windows.h>
#include <gl/Gl.h>
#include <gl/Glu.h>
//#include <gl/glut.h>
#include <gl/freeglut.h>

#include <stdio.h>
#include <math.h>

#define PI 3.1415926535897932384626433832795

void drawcube(float size);

void HSVtoRGB( GLfloat *r, GLfloat *g, GLfloat *b, GLfloat h, GLfloat s, GLfloat v );
void crossProduct(GLfloat *out, GLfloat *U,GLfloat *V);
GLfloat dotAngle(GLfloat *U, GLfloat *V );
void calcRotate( GLfloat angle, GLfloat *axis, GLfloat *rotation );
GLfloat dotProduct(GLfloat *U, GLfloat *V );


struct vec3
{
	float x;
	float y;
	float z;

	vec3();
};


//inline	Matrix3x3	Matrix3x3::Inverse(void)
//{
//	float	d = e11*e22*e33 - 
//				e11*e32*e23 + 
//				e21*e32*e13 - 
//				e21*e12*e33 + 
//				e31*e12*e23 - 
//				e31*e22*e13;
//
//	if (d == 0) d = 1;
//
//	return	Matrix3x3(	(e22*e33-e23*e32)/d,
//						-(e12*e33-e13*e32)/d,
//						(e12*e23-e13*e22)/d,
//						-(e21*e33-e23*e31)/d,
//						(e11*e33-e13*e31)/d,
//						-(e11*e23-e13*e21)/d,
//						(e21*e32-e22*e31)/d,
//						-(e11*e32-e12*e31)/d,
//						(e11*e22-e12*e21)/d );	
//}